#include <opencv2/highgui/highgui.hpp>
#include <iostream>

cv::VideoCapture vc;

void seek(int pos) {
	int frame_id_set = pos;
	if (!vc.set(CV_CAP_PROP_POS_FRAMES, frame_id_set))
		std::cout << "error: set" << std::endl;
	int frame_id_get = vc.get(CV_CAP_PROP_POS_FRAMES);
	std::cout << "set frame pos " << frame_id_set << ", get frame pos " << frame_id_get << std::endl;

	cv::Mat frame;
	if (!vc.read(frame)) {
		std::cout << "error: read" << std::endl;
	} else {
		std::cout << "read ok" << std::endl;
//		cv::imshow("Frame", frame);
//		cv::waitKey(100);
	}
}

int main(int argc, char ** argv) {
	const char * fn = "test3.avi";
	if (!vc.open(fn))
		std::cout << "error: open" << std::endl;

	int frame_count = vc.get(CV_CAP_PROP_FRAME_COUNT);
	std::cout << frame_count << " frames" << std::endl;

	seek(frame_count - 1);
	seek(frame_count - 2);
	seek(frame_count - 3);

	return 0;
}
